# -*- coding: utf-8 -*-

from grille_de_l_amour.carte.models import Pixel, NombreTotal

import Image
import sqlite3
import os

chemin_static ='./grille_de_l_amour/static/'

# Respecte l'orde des couleurs telles qu'affichées à l'écran dans la palette
TAB_COULEUR = ['000000', 'ffffff', 'ff0000', '0000ff', '00ff00', 'ffff00', 'ff00ff', '00ffff' ]

def ajout():
    
    # Cette partie construit une image png de 13*10 avec 
    # les informations de la base de données de la grille
    # et la sauvegrade dans le dossier static/images
    
    obj_temp = NombreTotal.objects.get(nom='nb_total')
    nb_images = int(obj_temp.valeur)

    export = Image.new('RGB', (13, 10))

    for i in range(130):

            for pixel in Pixel.objects.filter(nb = i):

                couleur_pixel_hex = TAB_COULEUR[int(pixel.couleur)]
                couleur_pixel_dec = int(couleur_pixel_hex, 16)

                rouge = (couleur_pixel_dec/256)/256
                vert = (couleur_pixel_dec/256)%256
                bleu = couleur_pixel_dec%256
                ligne = i/13
                colonne = i%13
                export.putpixel((colonne, ligne), (rouge, vert, bleu))
   
    numero_pix = 9000000000-nb_images-1   
    export.save(chemin_static + 'images/grille-{0}.png'.format(numero_pix))
    
    nb_images += 1

    obj_temp.valeur = nb_images
    obj_temp.save()


    # Cette partie ajoute l'image construite à matrice.png, image qui les contient toutes
    matrice = Image.open(chemin_static + 'matrice.png')

    nb_lignes = nb_images/30 # Attention, cette valeur est augmentée quand une ligne est complète
    nb_images_rest = nb_images%30

    if (nb_images_rest == 1):

        """
            Concerne la première image d'une nouvelle ligne
        """

        width = matrice.size[0]
        height = matrice.size[1]

        # Crée une image blanche vide plus grande que la matrice précédente
        # et copie la matrice dedans
        temp = Image.new('RGB', (width, height+10), 'white')
        temp.paste(matrice, (0, 0, width, height))

        x = 0
        y = nb_lignes * 10

        # Ajoute l'image construite en début de fonction
        # et sauvegarde
        temp.paste(export, (x, y, x+13, y+10))
        temp.save(chemin_static + 'matrice.png')

    else:

        if (nb_images_rest == 0):

            """
                Concerne la dernière image d'une ligne
            """

            x = 29 * 13
            y = (nb_lignes - 1) * 10

        else:
            x = (nb_images_rest -1) * 13
            y = nb_lignes * 10

        matrice.paste(export, (x, y, x+13, y+10))
        matrice.save(chemin_static + 'matrice.png')
